Bug 154318 - Multiple overlapping ext3 acl / noacl fs option instances reported in /proc/mounts
Multiple overlapping ext3 acl / noacl fs option instances reported in /proc/m...
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: util-linux (Show other bugs)
All Linux
medium Severity low
: ---
: ---
Assigned To: Karel Zak
Ben Levenson
Depends On:
  Show dependency treegraph
Reported: 2005-04-09 15:36 EDT by Stephen Gardner
Modified: 2008-03-19 10:02 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-03-19 10:02:08 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Stephen Gardner 2005-04-09 15:36:14 EDT
Description of problem:

The acl and noacl ext3 filesystem options are both reported in the output from 
mount  and contents of  /proc/mounts  which can be confusing. This was
discovered when attempting to remount (using the the mount command with the
noacl option) a filesystem which had   defaults,acl  specified in  /etc/fstab.

It should be noted that the last acl related option is the one put into affect
on the filesystem in question as expected, ie.  last option wins.

Version-Release number of selected component (if applicable):
RHEL4-U0 (i386, x86_86)
FC-RAWHIDE (i386) updated [07/04/2005]

How reproducible:

Steps to Reproduce:
1.   Have an entry in  /etc/fstab similar to

/dev/hda4    /data   ext3   defaults,acl  0 0

2a.  run      mount -o remount,noacl /data
2b.  or       mount -o remount,noacl,acl,noacl /data
2c.  or       mount -o remount,acl,acl,acl /data
3. See output from    mount  command  or contents of  /proc/mounts

Actual results:
Output (of 2a)  from mount  /  /proc/mounts  shows filesystem mounted as

/dev/hda4   /data ext3   rw,acl,noacl 0 0

[ or with as many additional acl and/or noacl options as specified ]

In the case of Step 2a (above), the  acl  option from  /etc/fstab  is being show
in addition to the opposing option specified in the mount command-line.

Expected results:
One the effective acl option would be reported in  /proc/mounts  eg.

/dev/hda4  /data  ext3  rw,noacl  0 0

Additional info:
If, for example multiple ro and rw options are specified when remounting then 
/proc/mounts  shows only the affective (last) option

mount -o remount,ro,ro,ro,ro,rw,ro /data

appears in /proc/mounts as
/dev/hda1  /boot  ext3 ro 0 0
This occurs with device mapper and standard /dev entries alike.
Interestingly n a non-RH system running vanilla v2.6.11.6 I reproduced the same
thing with reiserfs acl / noacl options so I acknowledge this may not required

Note to self: see English teacher regarding usage of {a,e}ffective instead of
flipping a coin to decide.
Comment 1 Stephen Tweedie 2005-04-12 05:21:46 EDT
acl/noacl options are not reported at all in /proc mounts:

[root@test ~]# mount /dev/test /mnt/test
[root@test ~]# mount -o remount,acl,noacl,acl /mnt/test/
[root@test ~]# mount |grep test
/dev/test on /mnt/test type ext3 (rw,acl,noacl,acl)
[root@test ~]# cat /proc/mounts | grep test
/dev/rest /mnt/test ext3 rw 0 0

These options are entirely maintained in user space by mount(8).  Reassigning.
Comment 2 Karel Zak 2005-04-12 09:51:13 EDT
No, these options are maintained in user space by mount(8) only for output to
/etc/mtab. But the mount command knows nothing about (no)acl.

There's two kinds of options:

a) standard options - parsed and interpreted by mount; an example rw/ro, (no)auto
b) extra options - mount doesn't parse it; an example (no)acl

There's no way how the mount can remove/optimalize extra options. You cannot
remove for example one item from the list of extra options if you know nothing
about meaning of item. Don't forget mount(8) is only common interface to
filesystem specific stuff.

Maybe we can think about some common way how work with [no]<option> for the
basic filesystems like ext2|3. But I'm sure that there's no playground for this
experiment in stable RHEL...
Comment 3 Stephen Gardner 2005-04-12 11:06:00 EDT
As I mentioned the issue does exist in FC-rawhide but I tend to report problems
against RHEL if I see them in an operational situation. As this "oddity" has
evidently been around for ages if you want to change the product to fc-devel for
experimentation assuming the issue is worth pursuing that seems sensible.

I was clearly mistaken about the (no)acl options being given in /proc/mounts 
which should've been mtab, too many windows open and cut-n-pastes flying around
that night, sorry. On reflection it does now surprise me that /proc/mounts
doesn't report all operational options on a filesystem.

Note You need to log in before you can comment on or make changes to this bug.